@echo off
@setlocal

@REM CONSOLE_ENCODING controls the output encoding used for stdout/stderr
@REM    console - encoding is correct for a console window
@REM    file    - encoding is the default file encoding for the system
@REM    <other> - the specified encoding is used.  e.g. Cp1252, Cp850, SJIS
@REM SET CONSOLE_ENCODING=-Dws.output.encoding=console

call "%~dp0setupCmdLine.bat" %*
set ANT_ARGS=-Dbasedir="%USER_INSTALL_ROOT%\samples" -Dwas_home="%WAS_HOME%" -Dprereq.classpath="%WAS_HOME%\runtimes\com.ibm.ws.webservices.thinclient_7.0.0.jar" 

set CMD_NAME=%~nx0
set CMD_NAME_ONLY=%~n0

:setArgs
if "%1"=="" goto doneArgs
set ANT_ARGS=%ANT_ARGS% %1
shift
goto setArgs

:doneArgs
set WAS_ANT_EXTRA_CLASSPATH=%WAS_HOME%\lib\bootstrap.jar;%WAS_HOME%\optionalLibraries\jython.jar;%WAS_HOME%\optionalLibraries\jython\jython.jar
set WAS_ANT_CLASSPATH=%WAS_ANT_CLASSPATH%;%WAS_HOME%\plugins;%WAS_HOME%\optionalLibraries\jython.jar;%WAS_HOME%\lib\j2ee.jar

REM Additional classpath elements needed by WebServicesSamples for BottomUp beans.
set WAS_ANT_CLASSPATH="%WAS_ANT_CLASSPATH:"=%;%USER_INSTALL_ROOT:"=%\samples\bld\WebServicesSamples\addrBeanBottomUp"
set WAS_ANT_CLASSPATH="%WAS_ANT_CLASSPATH:"=%;%USER_INSTALL_ROOT:"=%\samples\bld\WebServicesSamples\addrEJBBottomUp"

REM Ant requires classpath elements to exist before beginning...
call md "%USER_INSTALL_ROOT%\samples\bld\WebServicesSamples\addrBeanBottomUp"
call md "%USER_INSTALL_ROOT%\samples\bld\WebServicesSamples\addrBeanBottomUp\WEB-INF\classes"
call md "%USER_INSTALL_ROOT%\samples\bld\WebServicesSamples\addrEJBBottomUp"
call md "%USER_INSTALL_ROOT%\samples\bld\WebServicesSamples\addrEJBBottomUp\WEB-INF\classes"


@REM Generate a temporary path name for the properties file.  Be sure the dir exists and is writable.
@REM Try using the profile's temp space first before using the system's temp space.
if not defined USER_INSTALL_ROOT goto GEN_SYS_TMP_DIR
:GEN_TMP_DIR
set TMPWASDIR="%USER_INSTALL_ROOT:"=%\temp\%CMD_NAME_ONLY%.%RANDOM%"
if exist %TMPWASDIR% goto GEN_TMP_DIR
mkdir %TMPWASDIR%
if exist %TMPWASDIR% goto WRITE_PROPERTIES_FILE

:GEN_SYS_TMP_DIR
set TMPWASDIR="%TEMP:"=%\%CMD_NAME_ONLY%.%RANDOM%"
if exist %TMPWASDIR% goto GEN_SYS_TMP_DIR
mkdir %TMPWASDIR%
if not exist %TMPWASDIR% ( echo The TEMP environment variable must be set to a writable directory. ) & goto :EOF

:WRITE_PROPERTIES_FILE
set TMPJAVAPROPFILE="%TMPWASDIR:"=%\%CMD_NAME_ONLY%.properties"
@REM write one property per line into the temp file. - Format is propname=value   
@REM Remember to handle the "\" char in paths, as it must become two "\\" in order for java to handle properly.
>  %TMPJAVAPROPFILE% echo # Temporary Java Properties File for the %CMD_NAME% WAS command.
set TMPPROP=%WAS_HOME:\=\\%\\plugins;%WAS_EXT_DIRS:\=\\%;%WAS_ANT_CLASSPATH:\=\\%;
>> %TMPJAVAPROPFILE% echo ws.ext.dirs=%TMPPROP:"=%
set TMPPROP=%WAS_ANT_EXTRA_CLASSPATH:\=\\%
>> %TMPJAVAPROPFILE% echo was.ant.extra.classpath=%TMPPROP:"=%

set CLASSPATH=%WAS_CLASSPATH%

"%JAVA_HOME%\bin\java" -Dcmd.properties.file=%TMPJAVAPROPFILE% %WAS_LOGGING% %CONSOLE_ENCODING% "%CLIENTSAS%" "%CLIENTSSL%" "-DWAS_USER_SCRIPT=%WAS_USER_SCRIPT%" %USER_INSTALL_PROP% -Dwas.install.root="%WAS_HOME%" "-Dwas.root=%WAS_HOME%" com.ibm.ws.bootstrap.WSLauncher org.apache.tools.ant.Main %ANT_ARGS%

set RC=%ERRORLEVEL%

@REM Cleanup the temporary java properties file and dir.
del %TMPJAVAPROPFILE%
rmdir %TMPWASDIR%

@REM Need to pass the RC through the endlocal
@endlocal & exit /b %RC%